My Project: Level Class Reference

| My Project

Classes | Public Types | Public Member Functions | Static Public Member Functions | Friends | List of all members
Level Class Reference

`#include <level.h>`

## Classes
struct | ETag
struct | FTag
struct | VSpan
struct | VTag

## Public Types
enum | TopologyError { TOPOLOGY_MISSING_EDGE_FACES =0, TOPOLOGY_MISSING_EDGE_VERTS, TOPOLOGY_MISSING_FACE_EDGES, TOPOLOGY_MISSING_FACE_VERTS, TOPOLOGY_MISSING_VERT_FACES, TOPOLOGY_MISSING_VERT_EDGES, TOPOLOGY_FAILED_CORRELATION_EDGE_FACE, TOPOLOGY_FAILED_CORRELATION_FACE_VERT, TOPOLOGY_FAILED_CORRELATION_FACE_EDGE, TOPOLOGY_FAILED_ORIENTATION_INCIDENT_EDGE, TOPOLOGY_FAILED_ORIENTATION_INCIDENT_FACE, TOPOLOGY_FAILED_ORIENTATION_INCIDENT_FACES_EDGES, TOPOLOGY_DEGENERATE_EDGE, TOPOLOGY_NON_MANIFOLD_EDGE, TOPOLOGY_INVALID_CREASE_EDGE, TOPOLOGY_INVALID_CREASE_VERT }
typedef void(* | ValidationCallback) (TopologyError errCode, char const *msg, void const *clientData)

## Public Member Functions
| Level ()
| ~Level ()
int | getDepth () const
int | getNumVertices () const
int | getNumFaces () const
int | getNumEdges () const
int | getNumFaceVerticesTotal () const
int | getNumFaceEdgesTotal () const
int | getNumEdgeVerticesTotal () const
int | getNumEdgeFacesTotal () const
int | getNumVertexFacesTotal () const
int | getNumVertexEdgesTotal () const
int | getMaxValence () const
int | getMaxEdgeFaces () const
ConstIndexArray | getFaceVertices (Index faceIndex) const
ConstIndexArray | getFaceEdges (Index faceIndex) const
ConstIndexArray | getEdgeVertices (Index edgeIndex) const
ConstIndexArray | getEdgeFaces (Index edgeIndex) const
ConstIndexArray | getVertexFaces (Index vertIndex) const
ConstIndexArray | getVertexEdges (Index vertIndex) const
ConstLocalIndexArray | getEdgeFaceLocalIndices (Index edgeIndex) const
ConstLocalIndexArray | getVertexFaceLocalIndices (Index vertIndex) const
ConstLocalIndexArray | getVertexEdgeLocalIndices (Index vertIndex) const
float | getEdgeSharpness (Index edgeIndex) const
float | getVertexSharpness (Index vertIndex) const
Sdc::Crease::Rule | getVertexRule (Index vertIndex) const
Index | findEdge (Index v0Index, Index v1Index) const
void | setFaceHole (Index faceIndex, bool b)
bool | isFaceHole (Index faceIndex) const
Sdc::Options | getFVarOptions (int channel) const
int | getNumFVarChannels () const
int | getNumFVarValues (int channel) const
ConstIndexArray | getFaceFVarValues (Index faceIndex, int channel) const
FVarLevel & | getFVarLevel (int channel)
FVarLevel const & | getFVarLevel (int channel) const
void | setEdgeNonManifold (Index edgeIndex, bool b)
bool | isEdgeNonManifold (Index edgeIndex) const
void | setVertexNonManifold (Index vertIndex, bool b)
bool | isVertexNonManifold (Index vertIndex) const
VTag const & | getVertexTag (Index vertIndex) const
ETag const & | getEdgeTag (Index edgeIndex) const
FTag const & | getFaceTag (Index faceIndex) const
VTag & | getVertexTag (Index vertIndex)
ETag & | getEdgeTag (Index edgeIndex)
FTag & | getFaceTag (Index faceIndex)
bool | validateTopology (ValidationCallback callback=0, void const *clientData=0) const
void | print (const Refinement *parentRefinement=0) const
bool | isSingleCreasePatch (Index face, float *sharpnessOut=NULL, int *rotationOut=NULL) const
bool | doesVertexFVarTopologyMatch (Index vIndex, int fvarChannel) const
bool | doesFaceFVarTopologyMatch (Index fIndex, int fvarChannel) const
bool | doesEdgeFVarTopologyMatch (Index eIndex, int fvarChannel) const
void | getFaceVTags (Index fIndex, VTag vTags[], int fvarChannel=-1) const
void | getFaceETags (Index fIndex, ETag eTags[], int fvarChannel=-1) const
VTag | getFaceCompositeVTag (Index fIndex, int fvarChannel=-1) const
VTag | getFaceCompositeVTag (ConstIndexArray &fVerts) const
VTag | getVertexCompositeFVarVTag (Index vIndex, int fvarChannel) const
int | gatherQuadLinearPatchPoints (Index fIndex, Index patchPoints[], int rotation=0, int fvarChannel=-1) const
int | gatherQuadRegularInteriorPatchPoints (Index fIndex, Index patchPoints[], int rotation=0, int fvarChannel=-1) const
int | gatherQuadRegularBoundaryPatchPoints (Index fIndex, Index patchPoints[], int boundaryEdgeInFace, int fvarChannel=-1) const
int | gatherQuadRegularCornerPatchPoints (Index fIndex, Index patchPoints[], int cornerVertInFace, int fvarChannel=-1) const
int | gatherQuadRegularRingAroundVertex (Index vIndex, Index ringPoints[], int fvarChannel=-1) const
int | gatherQuadRegularPartialRingAroundVertex (Index vIndex, VSpan const &span, Index ringPoints[], int fvarChannel=-1) const
int | gatherTriRegularInteriorPatchPoints (Index fIndex, Index patchVerts[], int rotation=0) const
int | gatherTriRegularBoundaryVertexPatchPoints (Index fIndex, Index patchVerts[], int boundaryVertInFace) const
int | gatherTriRegularBoundaryEdgePatchPoints (Index fIndex, Index patchVerts[], int boundaryEdgeInFace) const
int | gatherTriRegularCornerVertexPatchPoints (Index fIndex, Index patchVerts[], int cornerVertInFace) const
int | gatherTriRegularCornerEdgePatchPoints (Index fIndex, Index patchVerts[], int cornerEdgeInFace) const
void | resizeFaces (int numFaces)
void | resizeFaceVertices (int numFaceVertsTotal)
void | resizeFaceEdges (int numFaceEdgesTotal)
void | resizeEdges (int numEdges)
void | resizeEdgeVertices ()
void | resizeEdgeFaces (int numEdgeFacesTotal)
void | resizeVertices (int numVertices)
void | resizeVertexFaces (int numVertexFacesTotal)
void | resizeVertexEdges (int numVertexEdgesTotal)
void | setMaxValence (int maxValence)
IndexArray | getFaceVertices (Index faceIndex)
IndexArray | getFaceEdges (Index faceIndex)
IndexArray | getEdgeVertices (Index edgeIndex)
IndexArray | getEdgeFaces (Index edgeIndex)
IndexArray | getVertexFaces (Index vertIndex)
IndexArray | getVertexEdges (Index vertIndex)
LocalIndexArray | getEdgeFaceLocalIndices (Index edgeIndex)
LocalIndexArray | getVertexFaceLocalIndices (Index vertIndex)
LocalIndexArray | getVertexEdgeLocalIndices (Index vertIndex)
float & | getEdgeSharpness (Index edgeIndex)
float & | getVertexSharpness (Index vertIndex)
int | createFVarChannel (int fvarValueCount, Sdc::Options const &options)
void | destroyFVarChannel (int channel)
IndexArray | getFaceFVarValues (Index faceIndex, int channel)
void | completeFVarChannelTopology (int channel, int regBoundaryValence)
int | getNumFaceVertices (Index faceIndex) const
int | getOffsetOfFaceVertices (Index faceIndex) const
int | getNumFaceEdges (Index faceIndex) const
int | getOffsetOfFaceEdges (Index faceIndex) const
int | getNumEdgeVertices (Index) const
int | getOffsetOfEdgeVertices (Index edgeIndex) const
int | getNumEdgeFaces (Index edgeIndex) const
int | getOffsetOfEdgeFaces (Index edgeIndex) const
int | getNumVertexFaces (Index vertIndex) const
int | getOffsetOfVertexFaces (Index vertIndex) const
int | getNumVertexEdges (Index vertIndex) const
int | getOffsetOfVertexEdges (Index vertIndex) const
ConstIndexArray | getFaceVertices () const
void | resizeFaceVertices (Index FaceIndex, int count)
void | resizeEdgeFaces (Index edgeIndex, int count)
void | trimEdgeFaces (Index edgeIndex, int count)
void | resizeVertexFaces (Index vertIndex, int count)
void | trimVertexFaces (Index vertIndex, int count)
void | resizeVertexEdges (Index vertIndex, int count)
void | trimVertexEdges (Index vertIndex, int count)
bool | completeTopologyFromFaceVertices ()
Index | findEdge (Index v0, Index v1, ConstIndexArray v0Edges) const
void | orientIncidentComponents ()
bool | orderVertexFacesAndEdges (Index vIndex, Index *vFaces, Index *vEdges) const
bool | orderVertexFacesAndEdges (Index vIndex)
void | populateLocalIndices ()
IndexArray | shareFaceVertCountsAndOffsets () const

## Static Public Member Functions
static char const * | getTopologyErrorString (TopologyError errCode)

## Friends
class | Refinement
class | TriRefinement
class | QuadRefinement

## Detailed Description

Definition at line 83 of file level.h.

## Member Typedef Documentation

## ◆ ValidationCallback

typedef void(* ValidationCallback) (TopologyError errCode, char const *msg, void const *clientData)

Definition at line 315 of file level.h.

## Member Enumeration Documentation

## ◆ TopologyError

enum TopologyError

Enumerator
TOPOLOGY_MISSING_EDGE_FACES |
TOPOLOGY_MISSING_EDGE_VERTS |
TOPOLOGY_MISSING_FACE_EDGES |
TOPOLOGY_MISSING_FACE_VERTS |
TOPOLOGY_MISSING_VERT_FACES |
TOPOLOGY_MISSING_VERT_EDGES |
TOPOLOGY_FAILED_CORRELATION_EDGE_FACE |
TOPOLOGY_FAILED_CORRELATION_FACE_VERT |
TOPOLOGY_FAILED_CORRELATION_FACE_EDGE |
TOPOLOGY_FAILED_ORIENTATION_INCIDENT_EDGE |
TOPOLOGY_FAILED_ORIENTATION_INCIDENT_FACE |
TOPOLOGY_FAILED_ORIENTATION_INCIDENT_FACES_EDGES |
TOPOLOGY_DEGENERATE_EDGE |
TOPOLOGY_NON_MANIFOLD_EDGE |
TOPOLOGY_INVALID_CREASE_EDGE |
TOPOLOGY_INVALID_CREASE_VERT |

Definition at line 290 of file level.h.

## Constructor & Destructor Documentation

## ◆ Level()

Level | ( |  | ) |

## ◆ ~Level()

~Level | ( |  | ) |

## Member Function Documentation

## ◆ completeFVarChannelTopology()

void completeFVarChannelTopology | ( | int | channel,
|  | int | regBoundaryValence
| ) |  |

## ◆ completeTopologyFromFaceVertices()

bool completeTopologyFromFaceVertices | ( |  | ) |

## ◆ createFVarChannel()

int createFVarChannel | ( | int | fvarValueCount,
|  | Sdc::Options const & | options
| ) |  |

## ◆ destroyFVarChannel()

void destroyFVarChannel | ( | int | channel | ) |

## ◆ doesEdgeFVarTopologyMatch()

bool doesEdgeFVarTopologyMatch | ( | Index | eIndex,
|  | int | fvarChannel
| ) |  | const

## ◆ doesFaceFVarTopologyMatch()

bool doesFaceFVarTopologyMatch | ( | Index | fIndex,
|  | int | fvarChannel
| ) |  | const

## ◆ doesVertexFVarTopologyMatch()

bool doesVertexFVarTopologyMatch | ( | Index | vIndex,
|  | int | fvarChannel
| ) |  | const

## ◆ findEdge() [1/2]

Index findEdge | ( | Index | v0,
|  | Index | v1,
|  | ConstIndexArray | v0Edges
| ) |  | const

## ◆ findEdge() [2/2]

Index findEdge | ( | Index | v0Index,
|  | Index | v1Index
| ) |  | const

## ◆ gatherQuadLinearPatchPoints()

int gatherQuadLinearPatchPoints | ( | Index | fIndex,
|  | Index | patchPoints[],
|  | int | rotation = `0`,
|  | int | fvarChannel = `-1`
| ) |  | const

## ◆ gatherQuadRegularBoundaryPatchPoints()

int gatherQuadRegularBoundaryPatchPoints | ( | Index | fIndex,
|  | Index | patchPoints[],
|  | int | boundaryEdgeInFace,
|  | int | fvarChannel = `-1`
| ) |  | const

## ◆ gatherQuadRegularCornerPatchPoints()

int gatherQuadRegularCornerPatchPoints | ( | Index | fIndex,
|  | Index | patchPoints[],
|  | int | cornerVertInFace,
|  | int | fvarChannel = `-1`
| ) |  | const

## ◆ gatherQuadRegularInteriorPatchPoints()

int gatherQuadRegularInteriorPatchPoints | ( | Index | fIndex,
|  | Index | patchPoints[],
|  | int | rotation = `0`,
|  | int | fvarChannel = `-1`
| ) |  | const

## ◆ gatherQuadRegularPartialRingAroundVertex()

int gatherQuadRegularPartialRingAroundVertex | ( | Index | vIndex,
|  | VSpan const & | span,
|  | Index | ringPoints[],
|  | int | fvarChannel = `-1`
| ) |  | const

## ◆ gatherQuadRegularRingAroundVertex()

int gatherQuadRegularRingAroundVertex | ( | Index | vIndex,
|  | Index | ringPoints[],
|  | int | fvarChannel = `-1`
| ) |  | const

## ◆ gatherTriRegularBoundaryEdgePatchPoints()

int gatherTriRegularBoundaryEdgePatchPoints | ( | Index | fIndex,
|  | Index | patchVerts[],
|  | int | boundaryEdgeInFace
| ) |  | const

## ◆ gatherTriRegularBoundaryVertexPatchPoints()

int gatherTriRegularBoundaryVertexPatchPoints | ( | Index | fIndex,
|  | Index | patchVerts[],
|  | int | boundaryVertInFace
| ) |  | const

## ◆ gatherTriRegularCornerEdgePatchPoints()

int gatherTriRegularCornerEdgePatchPoints | ( | Index | fIndex,
|  | Index | patchVerts[],
|  | int | cornerEdgeInFace
| ) |  | const

## ◆ gatherTriRegularCornerVertexPatchPoints()

int gatherTriRegularCornerVertexPatchPoints | ( | Index | fIndex,
|  | Index | patchVerts[],
|  | int | cornerVertInFace
| ) |  | const

## ◆ gatherTriRegularInteriorPatchPoints()

int gatherTriRegularInteriorPatchPoints | ( | Index | fIndex,
|  | Index | patchVerts[],
|  | int | rotation = `0`
| ) |  | const

## ◆ getDepth()

int getDepth | ( |  | ) | const
| inline

Definition at line 212 of file level.h.

## ◆ getEdgeFaceLocalIndices() [1/2]

LocalIndexArray getEdgeFaceLocalIndices | ( | Index | edgeIndex | ) |
| inline

Definition at line 716 of file level.h.

## ◆ getEdgeFaceLocalIndices() [2/2]

ConstLocalIndexArray getEdgeFaceLocalIndices | ( | Index | edgeIndex | ) | const
| inline

Definition at line 710 of file level.h.

## ◆ getEdgeFaces() [1/2]

IndexArray getEdgeFaces | ( | Index | edgeIndex | ) |
| inline

Definition at line 703 of file level.h.

## ◆ getEdgeFaces() [2/2]

ConstIndexArray getEdgeFaces | ( | Index | edgeIndex | ) | const
| inline

Definition at line 697 of file level.h.

## ◆ getEdgeSharpness() [1/2]

float & getEdgeSharpness | ( | Index | edgeIndex | ) |
| inline

Definition at line 744 of file level.h.

## ◆ getEdgeSharpness() [2/2]

float getEdgeSharpness | ( | Index | edgeIndex | ) | const
| inline

Definition at line 740 of file level.h.

## ◆ getEdgeTag() [1/2]

ETag& getEdgeTag | ( | Index | edgeIndex | ) |
| inline

Definition at line 284 of file level.h.

## ◆ getEdgeTag() [2/2]

ETag const& getEdgeTag | ( | Index | edgeIndex | ) | const
| inline

Definition at line 280 of file level.h.

## ◆ getEdgeVertices() [1/2]

IndexArray getEdgeVertices | ( | Index | edgeIndex | ) |
| inline

Definition at line 689 of file level.h.

## ◆ getEdgeVertices() [2/2]

ConstIndexArray getEdgeVertices | ( | Index | edgeIndex | ) | const
| inline

Definition at line 685 of file level.h.

## ◆ getFaceCompositeVTag() [1/2]

VTag getFaceCompositeVTag | ( | ConstIndexArray & | fVerts | ) | const

## ◆ getFaceCompositeVTag() [2/2]

VTag getFaceCompositeVTag | ( | Index | fIndex,
|  | int | fvarChannel = `-1`
| ) |  | const

## ◆ getFaceEdges() [1/2]

IndexArray getFaceEdges | ( | Index | faceIndex | ) |
| inline

Definition at line 595 of file level.h.

## ◆ getFaceEdges() [2/2]

ConstIndexArray getFaceEdges | ( | Index | faceIndex | ) | const
| inline

Definition at line 590 of file level.h.

## ◆ getFaceETags()

void getFaceETags | ( | Index | fIndex,
|  | ETag | eTags[],
|  | int | fvarChannel = `-1`
| ) |  | const

## ◆ getFaceFVarValues() [1/2]

IndexArray getFaceFVarValues | ( | Index | faceIndex,
|  | int | channel
| ) |  |

## ◆ getFaceFVarValues() [2/2]

ConstIndexArray getFaceFVarValues | ( | Index | faceIndex,
|  | int | channel
| ) |  | const

## ◆ getFaceTag() [1/2]

FTag& getFaceTag | ( | Index | faceIndex | ) |
| inline

Definition at line 285 of file level.h.

## ◆ getFaceTag() [2/2]

FTag const& getFaceTag | ( | Index | faceIndex | ) | const
| inline

Definition at line 281 of file level.h.

## ◆ getFaceVertices() [1/3]

ConstIndexArray getFaceVertices | ( |  | ) | const
| inline

Definition at line 582 of file level.h.

## ◆ getFaceVertices() [2/3]

IndexArray getFaceVertices | ( | Index | faceIndex | ) |
| inline

Definition at line 565 of file level.h.

## ◆ getFaceVertices() [3/3]

ConstIndexArray getFaceVertices | ( | Index | faceIndex | ) | const
| inline

Definition at line 560 of file level.h.

## ◆ getFaceVTags()

void getFaceVTags | ( | Index | fIndex,
|  | VTag | vTags[],
|  | int | fvarChannel = `-1`
| ) |  | const

## ◆ getFVarLevel() [1/2]

FVarLevel& getFVarLevel | ( | int | channel | ) |
| inline

Definition at line 268 of file level.h.

## ◆ getFVarLevel() [2/2]

FVarLevel const& getFVarLevel | ( | int | channel | ) | const
| inline

Definition at line 269 of file level.h.

## ◆ getFVarOptions()

Sdc::Options getFVarOptions | ( | int | channel | ) | const

## ◆ getMaxEdgeFaces()

int getMaxEdgeFaces | ( |  | ) | const
| inline

Definition at line 227 of file level.h.

## ◆ getMaxValence()

int getMaxValence | ( |  | ) | const
| inline

Definition at line 226 of file level.h.

## ◆ getNumEdgeFaces()

int getNumEdgeFaces | ( | Index | edgeIndex | ) | const
| inline

Definition at line 428 of file level.h.

## ◆ getNumEdgeFacesTotal()

int getNumEdgeFacesTotal | ( |  | ) | const
| inline

Definition at line 222 of file level.h.

## ◆ getNumEdges()

int getNumEdges | ( |  | ) | const
| inline

Definition at line 216 of file level.h.

## ◆ getNumEdgeVertices()

int getNumEdgeVertices | ( | Index |  | ) | const
| inline

Definition at line 425 of file level.h.

## ◆ getNumEdgeVerticesTotal()

int getNumEdgeVerticesTotal | ( |  | ) | const
| inline

Definition at line 221 of file level.h.

## ◆ getNumFaceEdges()

int getNumFaceEdges | ( | Index | faceIndex | ) | const
| inline

Definition at line 422 of file level.h.

## ◆ getNumFaceEdgesTotal()

int getNumFaceEdgesTotal | ( |  | ) | const
| inline

Definition at line 220 of file level.h.

## ◆ getNumFaces()

int getNumFaces | ( |  | ) | const
| inline

Definition at line 215 of file level.h.

## ◆ getNumFaceVertices()

int getNumFaceVertices | ( | Index | faceIndex | ) | const
| inline

Definition at line 419 of file level.h.

## ◆ getNumFaceVerticesTotal()

int getNumFaceVerticesTotal | ( |  | ) | const
| inline

Definition at line 219 of file level.h.

## ◆ getNumFVarChannels()

int getNumFVarChannels | ( |  | ) | const
| inline

Definition at line 264 of file level.h.

## ◆ getNumFVarValues()

int getNumFVarValues | ( | int | channel | ) | const

## ◆ getNumVertexEdges()

int getNumVertexEdges | ( | Index | vertIndex | ) | const
| inline

Definition at line 434 of file level.h.

## ◆ getNumVertexEdgesTotal()

int getNumVertexEdgesTotal | ( |  | ) | const
| inline

Definition at line 224 of file level.h.

## ◆ getNumVertexFaces()

int getNumVertexFaces | ( | Index | vertIndex | ) | const
| inline

Definition at line 431 of file level.h.

## ◆ getNumVertexFacesTotal()

int getNumVertexFacesTotal | ( |  | ) | const
| inline

Definition at line 223 of file level.h.

## ◆ getNumVertices()

int getNumVertices | ( |  | ) | const
| inline

Definition at line 214 of file level.h.

## ◆ getOffsetOfEdgeFaces()

int getOffsetOfEdgeFaces | ( | Index | edgeIndex | ) | const
| inline

Definition at line 429 of file level.h.

## ◆ getOffsetOfEdgeVertices()

int getOffsetOfEdgeVertices | ( | Index | edgeIndex | ) | const
| inline

Definition at line 426 of file level.h.

## ◆ getOffsetOfFaceEdges()

int getOffsetOfFaceEdges | ( | Index | faceIndex | ) | const
| inline

Definition at line 423 of file level.h.

## ◆ getOffsetOfFaceVertices()

int getOffsetOfFaceVertices | ( | Index | faceIndex | ) | const
| inline

Definition at line 420 of file level.h.

## ◆ getOffsetOfVertexEdges()

int getOffsetOfVertexEdges | ( | Index | vertIndex | ) | const
| inline

Definition at line 435 of file level.h.

## ◆ getOffsetOfVertexFaces()

int getOffsetOfVertexFaces | ( | Index | vertIndex | ) | const
| inline

Definition at line 432 of file level.h.

## ◆ getTopologyErrorString()

static char const* getTopologyErrorString | ( | TopologyError | errCode | ) |
| static

## ◆ getVertexCompositeFVarVTag()

VTag getVertexCompositeFVarVTag | ( | Index | vIndex,
|  | int | fvarChannel
| ) |  | const

## ◆ getVertexEdgeLocalIndices() [1/2]

LocalIndexArray getVertexEdgeLocalIndices | ( | Index | vertIndex | ) |
| inline

Definition at line 657 of file level.h.

## ◆ getVertexEdgeLocalIndices() [2/2]

ConstLocalIndexArray getVertexEdgeLocalIndices | ( | Index | vertIndex | ) | const
| inline

Definition at line 652 of file level.h.

## ◆ getVertexEdges() [1/2]

IndexArray getVertexEdges | ( | Index | vertIndex | ) |
| inline

Definition at line 646 of file level.h.

## ◆ getVertexEdges() [2/2]

ConstIndexArray getVertexEdges | ( | Index | vertIndex | ) | const
| inline

Definition at line 641 of file level.h.

## ◆ getVertexFaceLocalIndices() [1/2]

LocalIndexArray getVertexFaceLocalIndices | ( | Index | vertIndex | ) |
| inline

Definition at line 620 of file level.h.

## ◆ getVertexFaceLocalIndices() [2/2]

ConstLocalIndexArray getVertexFaceLocalIndices | ( | Index | vertIndex | ) | const
| inline

Definition at line 615 of file level.h.

## ◆ getVertexFaces() [1/2]

IndexArray getVertexFaces | ( | Index | vertIndex | ) |
| inline

Definition at line 609 of file level.h.

## ◆ getVertexFaces() [2/2]

ConstIndexArray getVertexFaces | ( | Index | vertIndex | ) | const
| inline

Definition at line 604 of file level.h.

## ◆ getVertexRule()

Sdc::Crease::Rule getVertexRule | ( | Index | vertIndex | ) | const
| inline

Definition at line 758 of file level.h.

## ◆ getVertexSharpness() [1/2]

float & getVertexSharpness | ( | Index | vertIndex | ) |
| inline

Definition at line 753 of file level.h.

## ◆ getVertexSharpness() [2/2]

float getVertexSharpness | ( | Index | vertIndex | ) | const
| inline

Definition at line 749 of file level.h.

## ◆ getVertexTag() [1/2]

VTag& getVertexTag | ( | Index | vertIndex | ) |
| inline

Definition at line 283 of file level.h.

## ◆ getVertexTag() [2/2]

VTag const& getVertexTag | ( | Index | vertIndex | ) | const
| inline

Definition at line 279 of file level.h.

## ◆ isEdgeNonManifold()

bool isEdgeNonManifold | ( | Index | edgeIndex | ) | const
| inline

Definition at line 782 of file level.h.

## ◆ isFaceHole()

bool isFaceHole | ( | Index | faceIndex | ) | const
| inline

Definition at line 770 of file level.h.

## ◆ isSingleCreasePatch()

bool isSingleCreasePatch | ( | Index | face,
|  | float * | sharpnessOut = `NULL`,
|  | int * | rotationOut = `NULL`
| ) |  | const

## ◆ isVertexNonManifold()

bool isVertexNonManifold | ( | Index | vertIndex | ) | const
| inline

Definition at line 791 of file level.h.

## ◆ orderVertexFacesAndEdges() [1/2]

bool orderVertexFacesAndEdges | ( | Index | vIndex | ) |

## ◆ orderVertexFacesAndEdges() [2/2]

bool orderVertexFacesAndEdges | ( | Index | vIndex,
|  | Index * | vFaces,
|  | Index * | vEdges
| ) |  | const

## ◆ orientIncidentComponents()

void orientIncidentComponents | ( |  | ) |

## ◆ populateLocalIndices()

void populateLocalIndices | ( |  | ) |

## ◆ print()

void print | ( | const Refinement * | parentRefinement = `0` | ) | const

## ◆ resizeEdgeFaces() [1/2]

void resizeEdgeFaces | ( | Index | edgeIndex,
|  | int | count
| ) |  |
| inline

Definition at line 723 of file level.h.

## ◆ resizeEdgeFaces() [2/2]

void resizeEdgeFaces | ( | int | numEdgeFacesTotal | ) |
| inline

Definition at line 834 of file level.h.

## ◆ resizeEdges()

void resizeEdges | ( | int | numEdges | ) |
| inline

Definition at line 816 of file level.h.

## ◆ resizeEdgeVertices()

void resizeEdgeVertices | ( |  | ) |
| inline

Definition at line 829 of file level.h.

## ◆ resizeFaceEdges()

void resizeFaceEdges | ( | int | numFaceEdgesTotal | ) |
| inline

Definition at line 811 of file level.h.

## ◆ resizeFaces()

void resizeFaces | ( | int | numFaces | ) |
| inline

Definition at line 799 of file level.h.

## ◆ resizeFaceVertices() [1/2]

void resizeFaceVertices | ( | Index | FaceIndex,
|  | int | count
| ) |  |
| inline

Definition at line 571 of file level.h.

## ◆ resizeFaceVertices() [2/2]

void resizeFaceVertices | ( | int | numFaceVertsTotal | ) |
| inline

Definition at line 807 of file level.h.

## ◆ resizeVertexEdges() [1/2]

void resizeVertexEdges | ( | Index | vertIndex,
|  | int | count
| ) |  |
| inline

Definition at line 663 of file level.h.

## ◆ resizeVertexEdges() [2/2]

void resizeVertexEdges | ( | int | numVertexEdgesTotal | ) |
| inline

Definition at line 858 of file level.h.

## ◆ resizeVertexFaces() [1/2]

void resizeVertexFaces | ( | Index | vertIndex,
|  | int | count
| ) |  |
| inline

Definition at line 626 of file level.h.

## ◆ resizeVertexFaces() [2/2]

void resizeVertexFaces | ( | int | numVertexFacesTotal | ) |
| inline

Definition at line 852 of file level.h.

## ◆ resizeVertices()

void resizeVertices | ( | int | numVertices | ) |
| inline

Definition at line 841 of file level.h.

## ◆ setEdgeNonManifold()

void setEdgeNonManifold | ( | Index | edgeIndex,
|  | bool | b
| ) |  |
| inline

Definition at line 778 of file level.h.

## ◆ setFaceHole()

void setFaceHole | ( | Index | faceIndex,
|  | bool | b
| ) |  |
| inline

Definition at line 766 of file level.h.

## ◆ setMaxValence()

void setMaxValence | ( | int | maxValence | ) |
| inline

Definition at line 677 of file level.h.

## ◆ setVertexNonManifold()

void setVertexNonManifold | ( | Index | vertIndex,
|  | bool | b
| ) |  |
| inline

Definition at line 787 of file level.h.

## ◆ shareFaceVertCountsAndOffsets()

IndexArray shareFaceVertCountsAndOffsets | ( |  | ) | const
| inline

Definition at line 865 of file level.h.

## ◆ trimEdgeFaces()

void trimEdgeFaces | ( | Index | edgeIndex,
|  | int | count
| ) |  |
| inline

Definition at line 732 of file level.h.

## ◆ trimVertexEdges()

void trimVertexEdges | ( | Index | vertIndex,
|  | int | count
| ) |  |
| inline

Definition at line 672 of file level.h.

## ◆ trimVertexFaces()

void trimVertexFaces | ( | Index | vertIndex,
|  | int | count
| ) |  |
| inline

Definition at line 633 of file level.h.

## ◆ validateTopology()

bool validateTopology | ( | ValidationCallback | callback = `0`,
|  | void const * | clientData = `0`
| ) |  | const

## Friends And Related Function Documentation

## ◆ QuadRefinement

friend class QuadRefinement
| friend

Definition at line 483 of file level.h.

## ◆ Refinement

friend class Refinement
| friend

Definition at line 481 of file level.h.

## ◆ TriRefinement

friend class TriRefinement
| friend

Definition at line 482 of file level.h.

The documentation for this class was generated from the following file:

- opensubdiv/vtr/level.h